Index: drivers/s390/block/dasd_3990_erp.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/s390/block/dasd_3990_erp.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/s390/block/dasd_3990_erp.c	22 Jul 2004 19:49:59 -0000	1.1
+++ drivers/s390/block/dasd_3990_erp.c	4 Aug 2004 01:29:28 -0000	1.2
@@ -1297,94 +1342,97 @@
 		case 0x00:
 			break;	/* No Message */
 		case 0x06:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT 9 - Device check-2 error");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT 9 - Device check-2 error");
 			break;
 		case 0x07:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT 9 - Head address did not compare");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT 9 - Head address did not compare");
 			break;
 		case 0x0A:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT 9 - Track physical address did "
-                                      "not compare while oriented");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT 9 - Track physical address did "
+                                     "not compare while oriented");
 			break;
 		case 0x0E:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT 9 - Cylinder address did not "
-                                      "compare");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT 9 - Cylinder address did not "
+                                     "compare");
 			break;
 		default:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT 9 - Reserved");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT 9 - Reserved");
 		}
                 break;		
 
 	case 0xF0:		/* Format F - Cache Storage Checks */
 		switch (msg_no) {
 		case 0x00:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Operation Terminated");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Operation Terminated");
 			break;
 		case 0x01:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Subsystem Processing Error");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Subsystem Processing Error");
 			break;
 		case 0x02:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Cache or nonvolatile storage "
-                                      "equipment failure");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Cache or nonvolatile storage "
+                                     "equipment failure");
 			break;
 		case 0x04:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Caching terminated");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Caching terminated");
 			break;
 		case 0x06:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Cache fast write access not "
-                                      "authorized");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Cache fast write access not "
+                                     "authorized");
 			break;
 		case 0x07:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Track format incorrect");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Track format incorrect");
 			break;
 		case 0x09:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Caching reinitiated");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Caching reinitiated");
 			break;
 		case 0x0A:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Nonvolatile storage "
-                                      "terminated");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Nonvolatile storage "
+                                     "terminated");
 			break;
 		case 0x0B:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Volume is suspended duplex");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Volume is suspended duplex");
 			break;
 		case 0x0C:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Subsystem status connot be "
-                                      "determined");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Subsystem status connot be "
+                                     "determined");
 			break;
 		case 0x0D:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - Caching status reset to "
-                                      "default");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - Caching status reset to "
+                                     "default");
 			break;
 		case 0x0E:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT F - DASD Fast Write inhibited");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT F - DASD Fast Write inhibited");
 			break;
 		default:
-                        DASD_MESSAGE (KERN_WARNING, device, "%s",
-                                      "FORMAT D - Reserved");
+                        DEV_MESSAGE (KERN_WARNING, device, "%s",
+                                     "FORMAT D - Reserved");
 		}
                 break;		
 
 	default:	/* unknown message format - should not happen */
-
+                DEV_MESSAGE (KERN_WARNING, device,
+                             "unknown message format %02x",
+                             msg_format);
+                
 	} /* end switch message format */
-
+        
 } /* end dasd_3990_handle_env_data */
 
 /*
@@ -1412,8 +1460,8 @@
 	/* env data present (ACTION 10 - retry should work) */
 	if (sense[2] & SNS2_ENV_DATA_PRESENT) {
 
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Command Reject - environmental data present");
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Command Reject - environmental data present");
 
 		dasd_3990_handle_env_data (erp,
                                            sense);
@@ -1422,8 +1470,8 @@
 
 	} else {
 		/* fatal error -  set status to FAILED */
-                DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "Command Reject - Fatal error");
+                DEV_MESSAGE (KERN_ERR, device, "%s",
+                             "Command Reject - Fatal error");
 
                 erp = dasd_3990_erp_cleanup (erp,
                                              CQR_STATUS_FAILED);
@@ -1460,9 +1508,9 @@
         } else {
 
                 /* issue a message and wait for 'device ready' interrupt */
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "bus out parity error or BOPC requested by "
-                              "channel");
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "bus out parity error or BOPC requested by "
+                             "channel");
                 
                 dasd_3990_erp_block_queue (erp,
                                            60);
@@ -1495,22 +1543,22 @@
 
 	if (sense[1] & SNS1_WRITE_INHIBITED) {
 
-		DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Write inhibited path encountered");
+		DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Write inhibited path encountered");
 
 		/* vary path offline */
-		DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "Path should be varied off-line. "
-                              "This is not implemented yet \n - please report "
-                              "to linux390@de.ibm.com");
+		DEV_MESSAGE (KERN_ERR, device, "%s",
+                             "Path should be varied off-line. "
+                             "This is not implemented yet \n - please report "
+                             "to linux390@de.ibm.com");
 
 		erp = dasd_3990_erp_action_1 (erp);
 
 	} else if (sense[2] & SNS2_ENV_DATA_PRESENT) {
                 
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Equipment Check - "
-                              "environmental data present");
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Equipment Check - "
+                             "environmental data present");
                 
                 dasd_3990_handle_env_data (erp,
                                            sense);
@@ -1519,17 +1567,18 @@
                                               sense);
                 
         } else if (sense[1] & SNS1_PERM_ERR) {
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Equipment Check - retry exhausted or "
-                              "undesirable");
+
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Equipment Check - retry exhausted or "
+                             "undesirable");
                 
                 erp = dasd_3990_erp_action_1 (erp);
                 
         } else {
                 /* all other equipment checks - Action 5 */
                 /* rest is done when retries == 0 */
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Equipment check or processing error");
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Equipment check or processing error");
                 
                 erp = dasd_3990_erp_action_5 (erp);
         }
@@ -1561,9 +1610,9 @@
 	if (sense[2] & SNS2_CORRECTABLE) {	/* correctable data check */
 
 		/* issue message that the data has been corrected */
-		DASD_MESSAGE (KERN_EMERG, device, "%s",
-                              "Data recovered during retry with PCI "
-                              "fetch mode active");
+		DEV_MESSAGE (KERN_EMERG, device, "%s",
+                             "Data recovered during retry with PCI "
+                             "fetch mode active");
 
                 /* not possible to handle this situation in Linux */    
                 panic("No way to inform appliction about the possibly "
@@ -1571,26 +1620,26 @@
 
 	} else if (sense[2] & SNS2_ENV_DATA_PRESENT) {
 
-		DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Uncorrectable data check recovered secondary "
-                              "addr of duplex pair");
+		DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Uncorrectable data check recovered secondary "
+                             "addr of duplex pair");
 
 		erp = dasd_3990_erp_action_4 (erp,
 					      sense);
 
 	} else if (sense[1] & SNS1_PERM_ERR) {
 
-		DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Uncorrectable data check with internal "
-                              "retry exhausted");
+		DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Uncorrectable data check with internal "
+                             "retry exhausted");
 
 		erp = dasd_3990_erp_action_1 (erp);
 
 	} else {
 		/* all other data checks */
-		DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Uncorrectable data check with retry count "
-                              "exhausted...");
+		DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Uncorrectable data check with retry count "
+                             "exhausted...");
 
 		erp = dasd_3990_erp_action_5 (erp);
 	}
@@ -1619,9 +1668,9 @@
 
 	erp->function = dasd_3990_erp_overrun;
 
-        DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                      "Overrun - service overrun or overrun"
-                      " error requested by channel");
+        DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                     "Overrun - service overrun or overrun"
+                     " error requested by channel");
 
         erp = dasd_3990_erp_action_5 (erp);
 
@@ -1651,9 +1700,9 @@
 
 	if (sense[2] & SNS2_ENV_DATA_PRESENT) {
 
-		DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Track format error when destaging or "
-                              "staging data");
+		DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Track format error when destaging or "
+                             "staging data");
 
 		dasd_3990_handle_env_data (erp,
                                            sense);
@@ -1662,9 +1711,9 @@
 					      sense);
 
 	} else {
-		DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "Invalid Track Format - Fatal error should have "
-                              "been handled within the interrupt handler");
+		DEV_MESSAGE (KERN_ERR, device, "%s",
+                             "Invalid Track Format - Fatal error should have "
+                             "been handled within the interrupt handler");
 
                 erp= dasd_3990_erp_cleanup (erp,
                                             CQR_STATUS_FAILED);
@@ -1692,8 +1741,8 @@
 
 	dasd_device_t *device = default_erp->device;
 
-        DASD_MESSAGE (KERN_ERR, device, "%s",
-                      "End-of-Cylinder - must never happen");
+        DEV_MESSAGE (KERN_ERR, device, "%s",
+                     "End-of-Cylinder - must never happen");
 
         /* implement action 7 - BUG */
         return dasd_3990_erp_cleanup (default_erp,
@@ -1721,8 +1770,8 @@
 
 	erp->function = dasd_3990_erp_env_data;
 
-        DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                      "Environmental data present");
+        DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                     "Environmental data present");
 
         dasd_3990_handle_env_data (erp,
                                    sense);
@@ -1761,9 +1810,9 @@
 
 	dasd_device_t *device = default_erp->device;
 
-        DASD_MESSAGE (KERN_ERR, device, "%s",
-                      "No Record Found - Fatal error should "
-                      "have been handled within the interrupt handler");
+        DEV_MESSAGE (KERN_ERR, device, "%s",
+                     "No Record Found - Fatal error should "
+                     "have been handled within the interrupt handler");
 
         return dasd_3990_erp_cleanup (default_erp,
                                       CQR_STATUS_FAILED);
@@ -1789,8 +1838,8 @@
 
 	dasd_device_t *device = erp->device;
 
-        DASD_MESSAGE (KERN_ERR, device, "%s",
-                      "File Protected");
+        DEV_MESSAGE (KERN_ERR, device, "%s",
+                     "File Protected");
 
         return dasd_3990_erp_cleanup (erp,
                                       CQR_STATUS_FAILED);
@@ -1921,8 +1970,8 @@
         erp->retries  = 256;
         erp->function = dasd_3990_erp_action_10_32;
 
-	DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                      "Perform logging requested");
+	DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                     "Perform logging requested");
 
 	return erp;
 
@@ -1960,8 +2009,8 @@
 	char           *LO_data;   /* LO_eckd_data_t */
         ccw1_t         *ccw;
 
-	DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                      "Write not finished because of unexpected condition");
+	DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                     "Write not finished because of unexpected condition");
         
         default_erp->function = dasd_3990_erp_action_1B_32;
 
@@ -1975,8 +2024,8 @@
         /* for imprecise ending just do default erp */
         if (sense[1] & 0x01) {
 
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Imprecise ending is set - just retry");
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Imprecise ending is set - just retry");
 
                 return default_erp;
         } 
@@ -1987,9 +2036,9 @@
         
         if (cpa == 0) {
                 
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Unable to determine address of the CCW "
-                              "to be restarted");
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Unable to determine address of the CCW "
+                             "to be restarted");
                 
                 return dasd_3990_erp_cleanup (default_erp,
                                               CQR_STATUS_FAILED);
@@ -2004,8 +2053,8 @@
 
 	if (!erp) {
 
-                DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "Unable to allocate ERP");
+                DEV_MESSAGE (KERN_ERR, device, "%s",
+                             "Unable to allocate ERP");
                 
                 return dasd_3990_erp_cleanup (default_erp,
                                               CQR_STATUS_FAILED);
@@ -2023,8 +2072,8 @@
         if ((sense[3]  == 0x01) &&
             (LO_data[1] & 0x01)   ){
 
-                DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "BUG - this should not happen");
+                DEV_MESSAGE (KERN_ERR, device, "%s",
+                             "BUG - this should not happen");
 
                 return dasd_3990_erp_cleanup (default_erp,
                                               CQR_STATUS_FAILED);
@@ -2060,8 +2109,8 @@
 	if (dasd_set_normalized_cda (ccw,
                                      __pa (DE_data), erp, device)) {
                 dasd_free_request (erp, device);
-                DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "Unable to allocate ERP");
+                DEV_MESSAGE (KERN_ERR, device, "%s",
+                             "Unable to allocate ERP");
 
                 return dasd_3990_erp_cleanup (default_erp,
                                               CQR_STATUS_FAILED);
@@ -2076,8 +2125,8 @@
 	if (dasd_set_normalized_cda (ccw, 
                                      __pa (LO_data), erp, device)){
                 dasd_free_request (erp, device);
-                DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "Unable to allocate ERP");
+                DEV_MESSAGE (KERN_ERR, device, "%s",
+                             "Unable to allocate ERP");
                 
                 return dasd_3990_erp_cleanup (default_erp,
                                               CQR_STATUS_FAILED);
@@ -2132,9 +2181,9 @@
 	char           *LO_data;   /* LO_eckd_data_t */
         ccw1_t         *ccw;
 
-	DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                      "Write not finished because of unexpected condition"
-                      " - follow on");
+	DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                     "Write not finished because of unexpected condition"
+                     " - follow on");
         
         /* determine the original cqr */
         cqr = previous_erp;
@@ -2146,8 +2195,8 @@
         /* for imprecise ending just do default erp */
         if (sense[1] & 0x01) {
 
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Imprecise ending is set - just retry");
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Imprecise ending is set - just retry");
 
                 check_then_set (&previous_erp->status,
                                 CQR_STATUS_ERROR,
@@ -2162,9 +2211,9 @@
         
         if (cpa == 0) {
                 
-                DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                              "Unable to determine address of the CCW "
-                              "to be restarted");
+                DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                             "Unable to determine address of the CCW "
+                             "to be restarted");
                 
                 check_then_set (&previous_erp->status,
                                 CQR_STATUS_ERROR,
@@ -2181,8 +2230,8 @@
         if ((sense[3]  == 0x01) &&
             (LO_data[1] & 0x01)   ){
 
-                DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "BUG - this should not happen");
+                DEV_MESSAGE (KERN_ERR, device, "%s",
+                             "BUG - this should not happen");
 
                 check_then_set (&previous_erp->status,
                                 CQR_STATUS_ERROR,
@@ -2337,7 +2386,7 @@
                 switch (sense[28]) {
                 case 0x17:
                         /* issue a Diagnostic Control command with an 
-                         * Inhibit Write subcommand and controler modifier */
+                                * Inhibit Write subcommand and controler modifier */
                         erp = dasd_3990_erp_DCTL (erp,
                                                   0x20);
                         break;
@@ -2351,7 +2400,7 @@
                         break;
                         
                 default:
-                        /* should not happen - continue */
+                        ; /* should not happen - continue */
 
                 }
         }
@@ -2389,11 +2438,11 @@
                 /* set to suspended duplex state then restart */
                 dasd_device_t *device  = erp->device;
 
-                DASD_MESSAGE (KERN_ERR, device, "%s",      
-                              "Set device to suspended duplex state should be "
-                              "done!\n"
-                              "This is not implemented yet (for compound ERP)"
-                              " - please report to linux390@de.ibm.com");
+                DEV_MESSAGE (KERN_ERR, device, "%s",      
+                             "Set device to suspended duplex state should be "
+                             "done!\n"
+                             "This is not implemented yet (for compound ERP)"
+                             " - please report to linux390@de.ibm.com");
                 
         }
 
@@ -2490,10 +2539,10 @@
 		switch (sense[25]) {
 
 		case 0x00:	/* success */
-                        DASD_MESSAGE (KERN_DEBUG, device,
-                                      "ERP called for successful request %p"
-                                      " - NO ERP necessary",
-                                      erp);
+                        DEV_MESSAGE (KERN_DEBUG, device,
+                                     "ERP called for successful request %p"
+                                     " - NO ERP necessary",
+                                     erp);
                         
                         erp = dasd_3990_erp_cleanup (erp,
                                                      CQR_STATUS_DONE);
@@ -2501,9 +2550,9 @@
                         break;
                         
 		case 0x01:	/* fatal error */
-                        DASD_MESSAGE (KERN_ERR, device, "%s",
-                                      "Fatal error should have been "
-                                      "handled within the interrupt handler");
+                        DEV_MESSAGE (KERN_ERR, device, "%s",
+                                     "Fatal error should have been "
+                                     "handled within the interrupt handler");
 
                         erp = dasd_3990_erp_cleanup (erp,
                                                      CQR_STATUS_FAILED);
@@ -2515,12 +2564,12 @@
                         break;
 
 		case 0x0F:	/* length mismatch during update write command */
-                        DASD_MESSAGE (KERN_ERR, device, "%s",
-                                      "update write command error - should not "
-                                      "happen;\n"
-                                      "Please send this message together with "
-                                      "the above sense data to linux390@de."
-                                      "ibm.com");
+                        DEV_MESSAGE (KERN_ERR, device, "%s",
+                                     "update write command error - should not "
+                                     "happen;\n"
+                                     "Please send this message together with "
+                                     "the above sense data to linux390@de."
+                                     "ibm.com");
 
                         erp = dasd_3990_erp_cleanup (erp,
                                                      CQR_STATUS_FAILED);
@@ -2532,12 +2581,12 @@
                         break;
 
 		case 0x15:	/* next track outside defined extend */
-                        DASD_MESSAGE (KERN_ERR, device, "%s",
-                                      "next track outside defined extend - "
-                                      "should not happen;\n"
-                                      "Please send this message together with "
-                                      "the above sense data to linux390@de."
-                                      "ibm.com");
+                        DEV_MESSAGE (KERN_ERR, device, "%s",
+                                     "next track outside defined extend - "
+                                     "should not happen;\n"
+                                     "Please send this message together with "
+                                     "the above sense data to linux390@de."
+                                     "ibm.com");
 
                         erp= dasd_3990_erp_cleanup (erp,
                                                     CQR_STATUS_FAILED);
@@ -2550,9 +2599,9 @@
                         break;
 
 		case 0x1C:	/* invalid data */
-                        DASD_MESSAGE (KERN_EMERG, device, "%s",
-                                      "Data recovered during retry with PCI "
-                                      "fetch mode active");
+                        DEV_MESSAGE (KERN_EMERG, device, "%s",
+                                     "Data recovered during retry with PCI "
+                                     "fetch mode active");
                         
                         /* not possible to handle this situation in Linux */    
                         panic("Invalid data - No way to inform appliction about "
@@ -2560,16 +2609,16 @@
 			break;
 
 		case 0x1D:	/* state-change pending */
-                        DASD_MESSAGE (KERN_DEBUG, device, "%s",
-                                      "A State change pending condition exists "
-                                      "for the subsystem or device");
+                        DEV_MESSAGE (KERN_DEBUG, device, "%s",
+                                     "A State change pending condition exists "
+                                     "for the subsystem or device");
 
                         erp = dasd_3990_erp_action_4 (erp,
                                                       sense);
 			break;
 
-		default:	/* all others errors - default erp  */
-                        
+		default:	
+                        ;       /* all others errors - default erp  */
 		}
 	}
 
@@ -2642,25 +2691,47 @@
 {
 
 	dasd_device_t *device = cqr->device;
+	ccw1_t *ccw;
 
 	/* allocate additional request block */
-	ccw_req_t *erp = dasd_alloc_request ((char *) &cqr->magic, 1, 0, cqr->device);
+	ccw_req_t *erp = dasd_alloc_request ((char *) &cqr->magic, 2, 0, cqr->device);
 
 	if (!erp) {
-
-                DASD_MESSAGE (KERN_ERR, device, "%s",
-                              "Unable to allocate ERP request");
+                if (cqr->retries <= 0) {
+                        DEV_MESSAGE (KERN_ERR, device, "%s",
+                                     "Unable to allocate ERP request (NO retries left)");
                 
-                check_then_set (&cqr->status,
-                                CQR_STATUS_ERROR,
-                                CQR_STATUS_FAILED);
+                        check_then_set (&cqr->status,
+                                        CQR_STATUS_ERROR,
+                                        CQR_STATUS_FAILED);
+
+                        cqr->stopclk = get_clock ();
 
+                } else {
+                        DEV_MESSAGE (KERN_ERR, device,
+                                     "Unable to allocate ERP request (%i retries left)",
+                                     cqr->retries);
+                
+                        if (!timer_pending(&device->timer)) {
+                                init_timer (&device->timer);
+                                device->timer.function = dasd_schedule_bh_timed;
+                                device->timer.data     = (unsigned long) device;
+                                device->timer.expires  = jiffies + (HZ << 3);
+                                add_timer (&device->timer);
+                        } else {
+                                mod_timer(&device->timer, jiffies + (HZ << 3));
+                        }
+                }
                 return cqr;
 	}
 
 	/* initialize request with default TIC to current ERP/CQR */
-	erp->cpaddr->cmd_code = CCW_CMD_TIC;
-	erp->cpaddr->cda      = (long)(cqr->cpaddr);
+	ccw = erp->cpaddr;
+	ccw->cmd_code = CCW_CMD_NOOP;
+	ccw->flags = CCW_FLAG_CC;
+	ccw++;
+	ccw->cmd_code = CCW_CMD_TIC;
+	ccw->cda      = (long)(cqr->cpaddr);
 	erp->function = dasd_3990_erp_add_erp;
 	erp->refers   = cqr;
 	erp->device   = cqr->device;
@@ -2738,7 +2809,7 @@
 	}
 
 	/* check sense data; byte 0-2,25,27 */
-	if (!((strncmp (cqr1->dstat->ii.sense.data,
+	if (!((memcmp (cqr1->dstat->ii.sense.data,
 			cqr2->dstat->ii.sense.data,
 			3) == 0) &&
 	      (cqr1->dstat->ii.sense.data[27] ==
@@ -2859,10 +2930,10 @@
                                 break;
                         }
                         default:
-                                DASD_MESSAGE (KERN_DEBUG, device,
-                                              "invalid subcommand modifier 0x%x "
-                                              "for Diagnostic Control Command",
-                                              sense[25]);
+                                DEV_MESSAGE (KERN_DEBUG, device,
+                                             "invalid subcommand modifier 0x%x "
+                                             "for Diagnostic Control Command",
+                                             sense[25]);
                         }
                 } 
 
